// 9. Parayti funkcij, kuri randa ir atspausdina
// visus odius, kuri pirmas simbolis sutampa su
// priepaskutiniu.

Program uzduotis_9;
Const Cg = 255;

 Type Dmas = array[1..Cg] of char;

 Type Tzodis = record
      zodis :  string;                    // visas zodis
      eilZodziai : integer;               // kiek eilute turi zodziu
      simb : Dmas;                        // simbolio masyvas
      ilg :  integer;                     // zodzio simboliu kiekis
 End;

 Type Tmas = array[1..Cg, 1..Cg] of Tzodis;



// Procedura, kuri nustato ar duomenu failas egzistuoja ir atidaro ji
// df - duomenu failo tekstas
Procedure DuomenuFailas(var df : text);
 var DuomF : string; IOR : integer;
Begin
    Repeat;
    Write('Iveskite duomenu failo varda: ');
    Readln(DuomF);
    Assign(df, DuomF);
{$I-}
   Reset(df);
{$I+}
    IOR := IOResult;

    if IOR <> 0 then
       begin
            Writeln('Ivyko klaida atidarant duomenu faila');
       end;
    Until IOR = 0;
End;



// Procedura, kuri nustato ar galima sukurti rezultatu faila ir sukuria ji
// rf - rezultatu failo tekstas
Procedure RezultatuFailas(var rf : text);
 var RezF:string; IOR : integer;
Begin
    Repeat;
    Write('Iveskite rezultatu failo varda: ');
    Readln(RezF);
    Assign(rf, RezF);
{$I-}
   Rewrite(rf);
{$I+}
    IOR := IOResult;

    if IOR <> 0 then
       begin
          Writeln('Rezultato failo sukurti negalima');
       end;
    Until IOR = 0;
End;



// Procedura nuskaityti duomenims is failo
// df - duomenu failo tekstas
// a - masyvas
// eil - kiek eiluciu yra tekste
Procedure nuskaitymas(var df : text; var a : Tmas; var eil : integer);
 var simb, zodis : integer; raide : char;
Begin
 simb := 0;
 eil := 0;
 While not eof(df) do
   begin
   
     eil := eil + 1;
     zodis:=1;
     While not eoln(df) do
        begin

          Read(df, raide);
          If raide <> ' ' then
              begin

                simb:=simb + 1;
                a[eil, zodis].simb[simb] := raide;
                a[eil, zodis].zodis := a[eil, zodis].zodis + raide;
                a[eil, 1].eilZodziai := zodis;

              end
             else
                 begin

                    zodis := zodis + 1;
                    simb := 0;
                    
                 end;
              a[eil, zodis].ilg := simb;
 end;
   simb := 0;
   Readln(df);
End;
   Close(df);
End;


// Funkcija patikrinti ar pirmas simbolis sutampa su priespaskutiniu
// eil - eilutes numeris
// zodis - zodzio numeris
Function ZodzioTikrinimas(var a : Tmas; eil, zodis : integer):string;
Begin
    If a[eil, zodis].simb[1] <> a[eil, zodis].simb[a[eil, zodis].ilg-1] then
        begin

           ZodzioTikrinimas := '';

       end else
         begin

           ZodzioTikrinimas := a[eil, zodis].zodis;

         end;
End;

// Procedura, kuri pertvarko teksta
// eil - eilutes numeris
Procedure tvarkymas(var a : Tmas; eil : integer);
 var i, j : integer;
Begin
    For i := 1 to eil do
       begin

            For j := 1 to a[i, 1].eilZodziai do
               begin

                    a[i, j].zodis := ZodzioTikrinimas(a, i, j);

               end;

       end;
End;

// Procedura, kuri isveda zodzius, kuriu pirmasis simbolis sutampa su pries-
// paskutiniu i rezultatu faila
// eil - eilutes numeris
Procedure isvedimas(var rf : text; var a : Tmas; var eil : integer);
 var i, j : integer;
Begin
    For i := 1 to eil do
       begin
       
          For j := 1 to a[i, 1].eilZodziai do
             begin
             
                If a[i, j].zodis <> ''
                   then Write(rf, a[i, j].zodis,' ');
                   
                If j = a[i, 1].eilZodziai
                   then WriteLn(rf);
             end;
       end;
    Close(rf);
End;



// Pagrindine programa
// a - masyvas
// eil - eilutes nr
 var df, rf : text; a : Tmas; eil : integer;
Begin
    DuomenuFailas(df);
    RezultatuFailas(rf);
    nuskaitymas(df, a, eil);
    tvarkymas(a, eil);
    isvedimas(rf, a, eil);
End.
